# $Revision: 1.25 $, $Date: 2012/02/05 20:02:08 $
# TODO
# - sync pl
%define		subver	pre3
%define		rel		4
Summary:	x86-64/x86 Machine Check Exceptions collector and decoder
Summary(pl.UTF-8):	Narzędzie do zbierania i dekodowania wyjątków MCE na platformie x86-64/x86
Name:		mcelog
Version:	1.0
Release:	0.%{subver}.%{rel}
License:	GPL v2
Group:		Applications/System
Source0:	http://www.kernel.org/pub/linux/utils/cpu/mce/%{name}-%{version}%{subver}.tar.gz
# Source0-md5:	b42f2214de6f4feb992556149edc67fa
Source1:	%{name}.logrotate
Source2:	%{name}.cron
Source3:	%{name}.init
Source4:	%{name}.sysconfig
Patch1:		%{name}-FHS.patch
Patch2:		manual.patch
Patch3:		bashism.patch
URL:		http://www.mcelog.org/
BuildRequires:	rpmbuild(macros) >= 1.228
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
Suggests:	crondaemon
ExclusiveArch:	%{ix86} %{x8664}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		statdir		/var/lib/misc

%description
mcelog is the user space backend for logging machine check errors
reported by the hardware to the kernel. The kernel does the immediate
actions (like killing processes etc.) and mcelog decodes the logs the
errors.

Starting with version 2.6.4 for x86-64 and 2.6.32 for x86, the Linux
kernel no longer decodes and logs recoverable Machine Check Exception
events to the kernel log on its own. It is recommended that mcelog
runs on all those machines.

Instead, the MCE data is kept in a buffer which can be read from
userpace via the /dev/mcelog device node. You need this tool to
collect and decode those events; it will log the decoded MCE events
into /var/log/mcelog.

%description -l pl.UTF-8
mcelog dekoduje zdarzenia Machine Check Exception (błędy sprzętowe) na
maszynach x86-64 pracujących pod kontrolą 64-bitowego jądra Linuksa.

Począwszy od wersji 2.6.4 jądro Linuksa dla x86-64 już samodzielnie
nie dekoduje ani nie loguje niekrytycznych zdarzeń MCE.

Zamiast tego dane MCE są przechowywane w buforze, który może być
czytany z przestrzeni użytkownika poprzez urządzenie /dev/mcelog. To
narzędzie jest potrzebne do zbierania i dekodowania tych zdarzeń;
loguje ono zdekodowane zdarzenia MCE do /var/log/mcelog. Aktualnie
mcelog potrafi dekodować MCE z procesorów AMD K8 i Intel P4 (w tym
Xeon).

%prep
%setup -q -n %{name}-%{version}%{subver}
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
%{__make} \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig,{cron,logrotate}.d},/var/log,%{statdir}}

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	etcprefix=$RPM_BUILD_ROOT

cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/cron.d/%{name}
cp -a %{SOURCE1} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}
install -p %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

:> $RPM_BUILD_ROOT%{statdir}/memory-errors

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service %{name} restart

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%files
%defattr(644,root,root,755)
%doc CHANGES README TODO TODO-diskdb mce.pdf
%attr(755,root,root) %{_sbindir}/mcelog
%attr(640,root,root) /etc/cron.d/mcelog
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/mcelog
%dir %{_sysconfdir}/%{name}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*.conf
# do replace on upgrade, in fact, these should be moved to /lib/mcelog as they
# all support foo.local invocation at the end
%attr(755,root,root) %config %verify(not md5 mtime size) %{_sysconfdir}/%{name}/*-trigger
%attr(640,root,root) %ghost %{statdir}/memory-errors
%{_mandir}/man8/mcelog.8*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mcelog.spec,v $
Revision 1.25  2012/02/05 20:02:08  arekm
- rel 4; drop empty config/pidfile from init file

Revision 1.24  2010/08/10 10:43:15  glen
- release 3

Revision 1.23  2010/08/10 10:42:34  glen
- avoid bash dep, rel 2

Revision 1.22  2010/08/10 10:39:45  glen
- overwrite triggers on upgrade

Revision 1.21  2010/08/10 10:35:09  glen
- supported on ix86 since 2.6.32
  list of valid cpu's can be obtained from mcelog --help, no point keeping (outdated) list here

Revision 1.20  2010/08/10 10:30:28  glen
- switch to daemon mode

Revision 1.19  2010/08/10 10:27:05  glen
- daaa, /etc/mcelog is a dir!

Revision 1.18  2010/08/10 10:25:59  glen
- logrotate is optional (should drop even the suggests?)

Revision 1.17  2010/08/10 10:21:35  glen
- move cronjob to a file

Revision 1.16  2010/08/10 10:01:38  glen
- setup cron by recommended 5 minute interval

Revision 1.15  2010/08/10 09:47:52  glen
- fix small typo in manual

Revision 1.14  2010/08/08 19:07:37  arekm
- rel .1 alwas be quiet

Revision 1.13  2010/02/01 21:44:18  gotar
- upgraded to 1.0pre3

Revision 1.12  2009/06/16 13:32:52  arekm
- release 4

Revision 1.11  2009/04/06 10:00:12  glen
- add FHS.patch; rel 3

Revision 1.10  2009/04/02 07:03:17  arekm
- rel .2

Revision 1.9  2008/10/08 19:49:34  qboosh
- don't lie, mark pre in release

Revision 1.8  2008/10/08 16:21:04  glen
- update to 0.8pre

Revision 1.7  2008/10/08 16:08:22  glen
- release 2

Revision 1.6  2008/10/08 16:07:15  glen
- release 1

Revision 1.5  2007/02/13 06:46:53  glen
- tabs in preamble

Revision 1.4  2007/02/12 01:06:41  baggins
- converted to UTF-8

Revision 1.3  2006/05/11 17:42:57  qboosh
- pl, EA (assuming it supports 32-bit userspace on 64-bit kernel too)

Revision 1.2  2006/05/08 12:31:11  glen
- unify cron.d file permission

Revision 1.1  2006/05/08 12:26:43  glen
- new
